/***
 * GASP: a gaming services platform for mobile multiplayer games.
 * MooDS: a communication protocol used in GASP.
 * GASP Demonstrator: a gasp demonstration game.
 *
 * Copyright (C) 2004 CNAM/INT
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 * 
 * Contact: gasp-team@objectweb.org
 *
 * Author: Franck Caron, Romain Pellerin
 */
/*
 * Created on 2 december 2005
 *
 * @author CARON Franck - CNAM CEDRIC
 * @author PELLERIN Romain - CNAM CEDRIC
 * 
 * 
 * Research project: CNAM-CEDRIC - INT - Filao
 */
//#include parameters.h
////#define DEMO
////#define VERSION_SOLO
////#define FRANCK
////#define LASTPING
////#define RESYNC

//#endinclude
/*
 * Created on 1 juin 2004
 *
 */
package app2.client;

import java.util.Vector;

/**
 * @author PELLERIN Romain (cybernash@free.fr) - MEGA Project 
 *
 */
public class ApplicationInstanceInfos {
	
	private int appInstanceID;
	private int nbP;
	private int min;
	private int max;
	private Vector pList;

	/**
	 * 
	 * @param applicationInstanceID
	 * @param minOfActors: the minimum number of actors required to start
	 * @param maxOfActors: the minimum number of actors
	 * @param nbPlayers: the number of actors in game
	 * @param playerList: a list of actor who can join the game
	 */
	public ApplicationInstanceInfos(int applicationInstanceID, int minOfActors, int maxOfActors, int nbPlayers, Vector playerList){
		appInstanceID= applicationInstanceID;
		nbP= nbPlayers;
		pList = playerList;
		min = minOfActors;
		max = maxOfActors;
	}
	
	public int getApplicationInstanceID(){return appInstanceID;}
	
	public int getNbPlayers(){return nbP;}
	
	public Vector getPlayerList(){return pList;}

    public int getMinActors() {
        return min;
    }

    public int getMaxActors() {
        return max;
    }
}
