/***
 * GASP: a gaming services platform for mobile multiplayer games.
 * MooDS: a communication protocol used in GASP.
 * GASP Demonstrator: a gasp demonstration game.
 *
 * Copyright (C) 2004 CNAM/INT
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 * 
 * Contact: gasp-team@objectweb.org
 *
 * Author: Franck Caron, Romain Pellerin
 */
/*
 * Created on 2 december 2005
 *
 * @author CARON Franck - CNAM CEDRIC
 * @author PELLERIN Romain - CNAM CEDRIC
 * 
 * 
 * Research project: CNAM-CEDRIC - INT - Filao
 */
//#include parameters.h
////#define DEMO
////#define VERSION_SOLO
////#define FRANCK
////#define LASTPING
////#define RESYNC

//#endinclude
/*
 * Created on 18 juin 2004
 */
package app2.client;


import java.util.Hashtable;
import java.util.Vector;

import javax.microedition.lcdui.Choice;
import javax.microedition.lcdui.Command;
import javax.microedition.lcdui.CommandListener;
import javax.microedition.lcdui.Display;
import javax.microedition.lcdui.Displayable;
import javax.microedition.lcdui.Form;
import javax.microedition.lcdui.Image;
import javax.microedition.lcdui.Item;
import javax.microedition.lcdui.List;
import javax.microedition.lcdui.StringItem;
import javax.microedition.lcdui.TextBox;
import javax.microedition.lcdui.TextField;
import javax.microedition.rms.RecordStore;
import javax.microedition.rms.RecordStoreException;
import javax.microedition.rms.RecordStoreFullException;
import javax.microedition.rms.RecordStoreNotOpenException;

import app2.client.game.GameCanvas;
import app2.client.game.SimpleGameCanvas;

/**
 * @author Cybernash, Maxime Wozny ,Alexandre Garc, Moez Habib Thameur, Franck CARON
 */
public class IHMGasp /*extends GASPClient*/ implements CommandListener,
        Runnable {
	/**
	 * The linked midlet
	 */
    protected App app;
  
    /**
	 * RMS
	 */ 
    private RecordStore recStore = null;
    private String dbRMS ="db_User1";
    
    /**
     * GASP ID 
     */ 
    private int aID;
    private int sID;
    public int aSID;
    	
    /**
     * GASP Infos
     */
    public boolean isOwner;
    private boolean isChangePseudo = false;
    private int ownerASID;
    private int[] currentAIIDList;
    private Vector appInstances;
    private Vector gameSessionPlayers;
    private boolean firstPlayer;
    private Integer integer;
    public String pseudoname;
    private int min;

    
    /**
     * mode, player is in:
     * 0 -> mainscreen
     * 1 -> lobby 
     * 2 -> waitingRoom
     * 3 -> inGame
     */
    public int mode; 
    
    
    /** 
     * Display all the vars
     */
    private Display display;
    private List list;
    
    private TextBox t;
    
    private StringItem si = new StringItem("Note:"," This is a GASP demonstrator. "+
    		"Let's hope it works! ;)");
    private StringItem version = new StringItem ("Version:"," 1.0.0");
    //private StringItem gaspProject = new StringItem(" ","                             ");

    private StringItem priv = new StringItem("Note:","If you want to create a private game, enter the authorized actors."+ "Please follow this pattern: 1_50_10_45_2");
    private TextField tfLogin = new TextField("Login:   ", "", 10, TextField.ANY);
    private TextField tfPwd = new TextField("Password:", "", 10, TextField.ANY);
    private TextField tfPseudo = new TextField("Pseudo:", "", 10, TextField.ANY);
    private TextField tfMin = new TextField("Minimum:", "", 10, TextField.NUMERIC);
    private TextField tfMax = new TextField("Maximum:", "", 10, TextField.NUMERIC);
    private TextField tfPriv = new TextField("Authorized actors:", "", 40, TextField.ANY);
    
    private Form formLogin = new Form("GASP log on");
    private Form formPseudo = new Form("Options");
    private Form formMinmax = new Form("Number of players");
    
    private Command currentCommand;
    private Thread commandThread;
    
    
    /**
     * quit the midlet
     */
    private Command exitCommand  = new Command("Exit", Command.EXIT, 2);
    
    /**
     * join the application instance selected in the list in the Lobby
     */
    private Command joinCommand = new Command("Join", Command.ITEM, 1);
    
    /**
     * login with the username and the password typed in the login screen
     */
	private Command loginCommand = new Command("Login", Command.SCREEN, 1);
	
	/**
	 * refesh the list of application instances in the Lobby
	 */
    private Command lobbyRefreshCommand = new Command("Refresh", Command.SCREEN, 1);
    
    /**
     * go to the new game creation screen when you are in the Lobby
     */
    private Command createCommand = new Command("Create", Command.SCREEN, 1);
    
    /**  
     * send data when you are in game
     */
    private Command dataCommand = new Command("SendData", Command.SCREEN, 1);
    
    /**
     * get the last events in the application instance when you are in 
     * the waiting room or in game
     */
    private Command eventsCommand = new Command("GetEvents", Command.SCREEN, 1);
    
    /**
     * starts the game when you are in the waiting room
     * the owner should be the only one allowed to use this command
     */
    private Command startCommand = new Command("Start Session", Command.SCREEN, 1);
    
    /** 
     * stop the game and return to the waiting room
     * the owner should be the only one allowed to use this command 
     */
    private Command endCommand = new Command("End Session", Command.SCREEN, 1);
    
    /**
     * quit GASP and return to the login screen
     */
    private Command quitCommand = new Command("Quit", Command.SCREEN, 1);
    
    /**
     * quit the application instance and retrun to the Lobby
     */
    private Command quitAICommand = new Command("Quit Session", Command.SCREEN, 1);
    
    /**
     * allow you to change your pseudo
     */
	private Command pseudoCommand = new Command("Options", Command.SCREEN, 1);
	
	/**
	 * used to confirm your new pseudo in the pseudo screen
	 */
	private Command okCommand = new Command("Ok", Command.SCREEN,1);
	
	/**
	 * used to cancel the choice you are currently doing (pseudo change or game creation)
	 */
	private Command cancelCommand = new Command("Cancel", Command.SCREEN, 1);
	
	/**
	 * when you are in the new game creation screen, create a game with the
	 * parameters you have chosen 
	 */
	private Command confirmCommand = new Command("Create", Command.SCREEN,1);

   
    /** Initialize the MIDlet with a handle to the current display */
    public IHMGasp(App m) {
        app = m;
        display = Display.getDisplay(app);
        appInstances = new Vector();
        isOwner = false;
        gameSessionPlayers = new Vector();
        mode = 0;
    	
        /**
         * build GASP login form
         */ 
        tfLogin.setPreferredSize(90,35);
        tfLogin.setLayout(Item.LAYOUT_CENTER);
        tfPwd.setPreferredSize(90,35);
        tfPwd.setLayout(Item.LAYOUT_CENTER);
    	version.setLayout(Item.LAYOUT_NEWLINE_AFTER);
    	
        formLogin.append(si);
        formLogin.append(tfLogin);
    	formLogin.append(tfPwd);
 
    	//gaspProject.setLayout(Item.LAYOUT_NEWLINE_AFTER);
    	//formLogin.append(gaspProject);
    	// add GASP research team logos
    	try{
    		formLogin.append(Image.createImage("/cnam.gif"));
    		formLogin.append(Image.createImage("/int.gif"));
    	}catch (Exception e){}
    	 	
       	formLogin.append(version);
    	formLogin.addCommand(loginCommand);
    	formLogin.addCommand(exitCommand);
    	
    	/**
    	 *  build GASP Minmax form
    	 */
    	formMinmax.append(tfMin);
    	formMinmax.append(tfMax);
    	formMinmax.append(priv);
    	formMinmax.append(tfPriv);
        formMinmax.addCommand(confirmCommand);
    	formMinmax.addCommand(cancelCommand);
    	
    	/**
    	 *  build GASP Pseudo form
    	 */
    	formPseudo.append(tfPseudo);
        formPseudo.addCommand(okCommand);
    	formPseudo.addCommand(cancelCommand);
    }
    /**
     * Debug output routine.
     * @param s string to be printed.
     */
    static final void DEBUG(String s) {
        if (true) {
            System.out.println(s);
        }
    }
      
    /**
     * Pause signals the thread to stop by clearing the thread field.
     * If stopped before done with the iterations it will
     * be restarted from scratch later.
     */
    public void startApp() {
        currentScreen();
    }
 
    /**
     * Respond to commands, including exit
     * @param c command to perform
     * @param s Screen displayable object
     */
    public void commandAction(Command c, Displayable s) {
        synchronized (this) {
            if (commandThread != null) {
                /**
                 *  process only one command at a time
                 */
                return;
            }
            currentCommand = c;
        	commandThread = new Thread(this);
        	commandThread.start();
        }
    }
    
    
    public void run() {
    	try{
        if (currentCommand == exitCommand) {
            app.notifyDestroyed();
        } else if (currentCommand == loginCommand) {
            login(tfLogin.getString(),tfPwd.getString());
        	if (sID>0) mode=1;
        	else alertScreen("Session has not been created");
        	currentScreen();
    	} else if (currentCommand == joinCommand) {
    	    join();
    	    if (aSID != 0) mode = 2;
    	    else alertScreen("This game session is no more joinable.");
        	currentScreen();
        } else if (currentCommand == createCommand) {
            createScreen();
        } else if (currentCommand == lobbyRefreshCommand) {
    	    currentScreen();
    	} else if (currentCommand == quitCommand) {
            if (isOwner){
            	if (mode == 2){
            	    //quitAI();
            		gameSessionPlayers.removeAllElements();
              		// networkCom.quitAI(aSID);
              	}
            	mode = 0;
            	quit();
        	    aSID=0;
        		
            }
            else if (mode!= 1){ 
                networkCom.quitAI(aSID);
                aSID = 0;
        	    gameSessionPlayers.removeAllElements();
            }
            networkCom.quit(sID);
            mode = 0;
            tfPwd.setString("");
            currentScreen();
        } else if (currentCommand == eventsCommand) {
        	networkCom.getEvents(aSID);
    	} else if (currentCommand == startCommand) {
        	if (networkCom.startAI(aSID)){
        		startGame();
        		isOwner = true;
        	}
        	else {
        		alertScreen("You cannot start the game");
        		mode=2;
        		}        	
        	currentScreen();
    	} else if (currentCommand == dataCommand) {
        	currentScreen();
    	} else if (currentCommand == endCommand) {
    		networkCom.endAI(aSID);
        	mode = 2;
    	    currentScreen();
    	} else if (currentCommand == quitAICommand) {
    		networkCom.quitAI(aSID);
    		this.quitAI();
    		aSID = 0;
    	    gameSessionPlayers.removeAllElements();
    	    mode = 1;
    	    currentScreen();
    	} else if (currentCommand == pseudoCommand) {
    	    changePseudoScreen();
    	}else if (currentCommand == okCommand) {
    		changePseudo();
    	    currentScreen();
    	} else if (currentCommand == cancelCommand) {
    		cancelValue();
       	}else if (currentCommand == confirmCommand) {
    		firstPlayer = true;
    		isOwner = true;
    		create();
    	} 
    	
    	}catch (Exception e){ e.printStackTrace();}

        synchronized (this) {
            // signal that another command can be processed
            commandThread = null;
        }
    }
 
    /**
     * 
	 * This method is called when a player try to create a game session.
	 * A player can create a public game session or a private game session
	 * 
	 */
   
	private void create() {
		int minActors = Integer.parseInt(tfMin.getString());
		int maxActors = Integer.parseInt(tfMax.getString());
		String actorsHttp = tfPriv.getString();
		if (minActors>maxActors)
		{		
			alertScreen("The session could not be started.");
			currentScreen();
			}
		else {
			if ("".equals(actorsHttp)){
			aSID = networkCom.createAI(sID,minActors,maxActors);
			min=minActors;
			mode =2;
			currentScreen();
			}
			else{
			/**TODO: private session  /aSID = createAIPriv(sID,actorsHttp,minActors,maxActors);*/
			min = minActors;
			mode=2;
			currentScreen();
			}
		}	
	}

	/**
     * Set the funtion to perform based on commands selected.
     * @param d Displayable object 
     * @param isLobby flag to indicate list processing
     */
    void setCommands(Displayable d, int commandMode) {
        switch (commandMode){
        	case 0: 
        	    d.addCommand(loginCommand);
        	    break;
        	    
        	case 1: 
        		/**
        		 *  Lobby with currently no sessions commands
        		 */
        	    d.addCommand(createCommand);
                d.addCommand(lobbyRefreshCommand);
                d.addCommand(quitCommand);
                break;
        	    
        	case 2: 
        		/**
        		 * Lobby with currently sessions commands
        		 */ 
        	    d.addCommand(joinCommand);
                d.addCommand(createCommand);
                d.addCommand(lobbyRefreshCommand);
                d.addCommand(quitCommand);
        	    break;
        	    
        	case 3: 
        		/**
        		 * Waiting room commands
        		 */ 
        		//#ifdef DEMO
        	    //# d.addCommand(eventsCommand);
        	    //#endif DEMO
        	    d.addCommand(pseudoCommand);
                if (isOwner) d.addCommand(startCommand);
                d.addCommand(quitAICommand);
                d.addCommand(quitCommand);
        	    break;
        	    
        	case 4: 
        		/**
        		 * In Game room commands
        		 */ 
        	    d.addCommand(eventsCommand);
                d.addCommand(dataCommand);
                if (isOwner) d.addCommand(endCommand);
                d.addCommand(quitAICommand);
                d.addCommand(quitCommand);
        	    break;
        	         	            	    
        	default: break;
        }
        d.setCommandListener(this);
    }

    /**
     * This methods provides to draw the appropriate screen.
     */
    public void currentScreen() {
        switch (mode){
        	case 0:
        	    mainScreen();
        	    break;
        	case 1:
        	    lobbyScreen();
        	    break;
        	case 2:
        	    waitingRoomScreen();
        	    break;
        	/*case 3:
        	    inGameScreen();*/
                    	    
        	default: break;	    
        } 
    }
    /**
     *  Link to the network communication object
     */
    private NetworkCom networkCom;
    
    /**************************************/
    /********* Displays management ********/
    /**************************************/
   
    /**
     * Main screen.
     */
    void mainScreen() {
        formLogin.setCommandListener(this);
    	display.setCurrent(formLogin);
    	networkCom = new NetworkCom(this);
        tfPwd.setString("");
    }
    
    /**
     * Lobby screen.
     */
    void lobbyScreen() {
    	try{
    	    firstPlayer = false;
    	    isOwner = false;
    	    appInstances = networkCom.getApplicationInstances(sID);
	    	int  indexMax = appInstances.size();
	    	currentAIIDList = new int[indexMax];
	    	
	    	if (indexMax == 0){
	    	    String s = "Note: Currently no game sessions to join";
	    	    t = new TextBox("GASP: Lobby Room", s, s.length(), 0);
	    	    setCommands(t, 1);
	    	    t.setCommandListener(this);
	    	    display.setCurrent(t);
	    	}
	    	else{
	    	    list = new List("GASP: Lobby Room", Choice.EXCLUSIVE);
	    	    list.setCommandListener(this);
	    	    list.append("Random session", null);
	    	    
		        for (int i = 0; i < appInstances.size(); i++) {
		            ApplicationInstanceInfos appInfos = (ApplicationInstanceInfos)appInstances.elementAt(i);
		            currentAIIDList[i] = appInfos.getApplicationInstanceID();
		            int aIID = appInfos.getApplicationInstanceID();
		            int nbP = appInfos.getNbPlayers();
		            int min = appInfos.getMinActors();
		            int max = appInfos.getMaxActors();
		            list.append("ApplicationInstanceID: "+aIID+ " nbPlayers: "+min+"/"+ nbP+"/"+ max, null);
		        }
		        setCommands(list, 2);
		        display.setCurrent(list);
	    	}
    	}
    	catch (Exception e){e.printStackTrace();}
    }
    
    /**
     * Waiting room screen.
     */
    void waitingRoomScreen() {
        try{
        	networkCom.startComThread();
	    	list = new List("Waiting Room - Players", Choice.EXCLUSIVE);
	    	list.setCommandListener(this);
	        for (int i = 0; i < gameSessionPlayers.size(); i++) {
	        	Integer aSIDOf = new Integer(0);
	        	try {
	        		aSIDOf = (Integer)gameSessionPlayers.elementAt(i);
	        	}
	        	catch (Exception e){
	        	}
	            if (aSIDOf.intValue()== ownerASID){
	                if (ownerASID == aSID)
	                    list.append("Owner(you): "+gameSessionPlayers.elementAt(i+1)+" ("+aID+","+sID+","+aSID+")",null);
	     
	                else
	                    list.append("Owner: "+gameSessionPlayers.elementAt(i+1)+" ("+aSIDOf+")",null);
	            }
	            else{
	                if (aSIDOf.intValue()== aSID){
	                    list.append("Player(you): "+gameSessionPlayers.elementAt(i+1)+" ("+aID+","+sID+","+aSID+")",null);
	                }
	      
	                else 
	                    list.append("Player: "+gameSessionPlayers.elementAt(i+1)+" ("+aSIDOf+")",null);	
	            }
	            i++;
	    	}
	        setCommands(list, 3);
            display.setCurrent(list);
    	}
    	catch (Exception e){e.printStackTrace();}
    }
    
	/**
	 * Create screen
	 * Perform a GASP create form to have min and max players
	 * + private game authorized actors list if necessary
	 */
	void createScreen() {	
        try{
    		tfMin.setString("");
    		tfMax.setString("");
        	formMinmax.setCommandListener(this);
        	display.setCurrent(formMinmax);
        	
    	}
    	catch (Exception e){e.printStackTrace();}
    }

    
    /**
     * ChangePseudo screen.
     */
    void changePseudoScreen() {
        try{
        	pseudoname = networkCom.name(aSID,tfPseudo.getString());
        	tfPseudo.setString((String) gameSessionPlayers.elementAt(getIndex(aSID)+1));
        	DEBUG("Pseudo:"+tfPseudo.getString());
        	formPseudo.setCommandListener(this);
	    	display.setCurrent(formPseudo);
	    	isChangePseudo = true;
    	}
    	catch (Exception e){e.printStackTrace();}
    }
    
    
    /**
     * In Game screen.
     */
    void inGameScreen() {
        try{
        	networkCom.getEvents(aSID);
	    	list = new List("In Game", Choice.EXCLUSIVE);
	    	list.setCommandListener(this);
	        for (int i = 0; i < gameSessionPlayers.size(); i++) {
	            Integer aSIDOf = (Integer)gameSessionPlayers.elementAt(i);
	            if (aSIDOf.intValue()== ownerASID){
	                if (ownerASID == aSID)
	                    list.append("Owner(you): "+gameSessionPlayers.elementAt(i+1)+" ("+aID+","+sID+","+aSID+")",null);
	     
	                else
	                    list.append("Owner: "+gameSessionPlayers.elementAt(i+1)+" ("+aSIDOf+")",null);
	            }
	            else{
	                if (aSIDOf.intValue()== aSID)
	                    list.append("Player(you): "+gameSessionPlayers.elementAt(i+1)+" ("+aID+","+sID+","+aSID+")",null);
	                else 
	                    list.append("Player: "+gameSessionPlayers.elementAt(i+1)+" ("+aSIDOf+")",null);	
	            }
	            i++;
	    	}
	        setCommands(list, 4);
	        display.setCurrent(list);
    	}
    	catch (Exception e){e.printStackTrace();}
    }
      
    /**
     * Alert screen.
     */
    synchronized void alertScreen(String s) {
        t = new TextBox("Alert", s, s.length(), 0);
        display.setCurrent(t);
        try {
            Thread.sleep(1300);
        } catch (InterruptedException e) {
            e.printStackTrace();
        }
    }
    
    /**
     * Cancel command 
     * Go back to previous screen (lobby screen or inGame screen)
     */
    private void cancelValue(){
    	if (isChangePseudo){
    		changePseudo();
    		waitingRoomScreen();
    		isChangePseudo = false;
    	}
    	else {
    		tfMin.setString("");
    		tfMax.setString("");
    		lobbyScreen();
    	}  		
      }
    
    /**
     * Test the change pseudo function.
     */
    private void changePseudo() {
    	pseudoname = networkCom.name(aSID,tfPseudo.getString());
    	if (pseudoname.equals("")) gameSessionPlayers.setElementAt(tfPseudo.getString(),getIndex(aSID)+1);
    	else gameSessionPlayers.setElementAt(pseudoname,getIndex(aSID)+1);
    	currentScreen();
    }

    
    /*********************************************/
    /****** specific informations for GASP *******/
    /*********************************************/
    
    /**
     * The application ID on GASP
     */
    private static final int applicationID = 2;
    
    /**
	 * Perform a GASP firstLogin or login,
	 * pick an alert screen and go to lobby screen.
	 */
	private void login(String loginName, String pwd) {
	    openRecordStore();
		byte[] aIDBytes = null;
		String aIDs = "";
		int nb = 0;
		try {
			nb = recStore.getNumRecords();
			
			if (nb==0){
				int actorID = networkCom.firstLogin(applicationID,loginName,pwd);
				DEBUG("firstLogin called with aID="+actorID);
				aIDs = "aID"+actorID;
				aIDBytes = aIDs.getBytes();
				recStore.addRecord(aIDBytes,0, aIDBytes.length);
			}
			else{
			    
				aIDBytes = recStore.getRecord(1);
				aIDs = new String(aIDBytes,0,aIDBytes.length);
				DEBUG("login called with aID="+aIDs);
			}
			
			int i = aIDs.length();
			aIDs = aIDs.substring(3,i);
			aID = Integer.parseInt(aIDs);
			sID = networkCom.login(aID,loginName,pwd,"2.0");
			DEBUG("login ok: sID n"+sID);
			nb = recStore.getNumRecords();
		} 
		catch (RecordStoreNotOpenException e) {
			e.printStackTrace();
		}
		catch (RecordStoreFullException e) {
			e.printStackTrace();
		}
		catch (RecordStoreException e) {
			e.printStackTrace();
		}
		catch (Exception e){
			e.printStackTrace();
		}
		alertScreen("Your infos : ActorID>"+aID+" Session ID>"+ sID);
	}
	
	/**
	 * Perform a GASP joinAIRnd or joinAI,
	 * and go to waitingRoomScreen.
	 */
	private void join() {
		if (list.getSelectedIndex()==0){
			/**
			 * join random option selected
			 */
			aSID = networkCom.joinAIRnd(sID);
		}
		else{
			aSID = networkCom.joinAI(sID,currentAIIDList[list.getSelectedIndex ()-1]);
		}
	}
	
	
	/**
	 *  Open the rms db
	 */
	private void openRecordStore() {
		try
	    {
	       /** The second parameter indicates that the record store
	        * should be created if it does not exist
	        */
	      recStore = RecordStore.openRecordStore(dbRMS, true );
	    }
	    catch (Exception e)
	    {
	      System.err.println(e.toString());
	    }
	}

	/**
	 * Write a record in rms db.
	 * 
	 * @param str the string to write
	 */
	private void writeRecord(String str)
	  {
	    byte[] rec = str.getBytes();
	 
	    try
	    {
	      recStore.addRecord(rec, 0, rec.length);
	      DEBUG("Writing record: " + str);
	    }
	    catch (Exception e)
	    {
	      System.err.println(e.toString());
	    }
	  }
	
	
    /**********************************************************/
	/** Implementation of the herited GASP events listeners ***/
	/**********************************************************/
    
    public void onJoinEvent(int actorSessionID, String username) {
        /**
         *  the first player join the application instance is the owner
         */
        DEBUG("JoinEvent:" + actorSessionID);
        
        if (actorSessionID == aSID) pseudoname = username;
        
        int i = getIndex(actorSessionID);
        DEBUG("Index of actorSessionID:"+i);
        if(i>=0){
        	// rename case
        	gameSessionPlayers.setElementAt(username,i+1);
        }
        else{
        	// no player with this aSID in gameSessionPlayers vector
        	firstPlayer = (gameSessionPlayers.size() == 0);
        	
            gameSessionPlayers.insertElementAt(new Integer(actorSessionID),gameSessionPlayers.size());
            gameSessionPlayers.insertElementAt(username,gameSessionPlayers.size());
            
            if (firstPlayer){ 
	            ownerASID = actorSessionID;
	            if (ownerASID==aSID){
	                isOwner = true;
	                alertScreen("Note: you are the owner of the game session");
	            }
	            else alertScreen("The game session owner joins: aSID>"+actorSessionID+" username>"+username);
            }
            else{
                if (actorSessionID!=aSID)
                    alertScreen("A new player joins: aSID>"+actorSessionID+" username>"+username);
            }
        }
        
        currentScreen();
    }
    
   
    /*********************************/
    /******* GAME MANAGEMENT *********/
    /*********************************/
    
    /**
     * game canvas link
     */
    protected GameCanvas gameCanvas;
    
    
    public void startGame() {
    	System.out.println("The game starts!");
    	mode = 3;
        /** 
         * initialize game
         */
    	gameCanvas = new SimpleGameCanvas(app, this, (int) NetworkCom.minimalRequestDeltaTime);
        gameCanvas.initialize();
        
        /**
         *  set game display
         */
        display.setCurrent(gameCanvas);
        
        /**
         *  start game
         */
		gameCanvas.newGame();
		gameCanvas.restart();
    }
    public void onStartEvent(int actorSessionID) {
       if (mode == 2){
	    	alertScreen("The game session owner starts the game!");
	    	startGame();
       }  
    }

    public void onEndEvent(int actorSessionID) {
        gameCanvas.stop();
       if (ownerASID==actorSessionID){
	    	alertScreen("The game session owner has stopped the game! Return to waiting room.");
 	        }
        else {
        	alertScreen("The player n "+actorSessionID+" left the game alone! ");
 	         }
        mode = 2;
        currentScreen();
    }

    public void onQuitEvent(int actorSessionID) {
    	if (mode==2){
	        if (ownerASID == actorSessionID){
	            alertScreen("The game session owner has left the game, the game session has been distructed." +
	            		" Return to the Lobby.");
	            gameSessionPlayers.removeAllElements();
	            mode = 1;
	            currentScreen();
	        }
	        else{
	        	if (/*isOwner && */min>gameSessionPlayers.size()/2)
	            	{
	            	alertScreen("The player n"+actorSessionID+" has left the game" +" Beware! The number of players is too low.");
	            	removePlayer(actorSessionID);
	            	}
	        	else {
	        		alertScreen("The player n"+actorSessionID+" has left from lobby");
	        		removePlayer(actorSessionID);
	        	}
	            currentScreen();
	        }
    	}
    	if (mode == 3){
    		if (ownerASID == actorSessionID){
	            alertScreen("The game session owner has left the game, the game has been distructed." +
	            		" Return to the Lobby Room.");
	            gameSessionPlayers.removeAllElements();
	            mode = 1;
	            currentScreen();
	        }
    		else{
    			gameSessionPlayers.removeElementAt(actorSessionID);
    			removePlayer(actorSessionID);
  				if (/*isOwner &&*/min>gameSessionPlayers.size()/2)
	            	{
	        		alertScreen("The player n"+actorSessionID+" has left the game" +" Beware! The number of players is too low.");
	        		mode = 2;
	            	currentScreen();
	            	}
	        	else {
	        		alertScreen("The player n"+actorSessionID+" has left the game and go to lobby room or GASP log on");
	        	    gameCanvas.onQuitEvent(actorSessionID);
	        		display.setCurrent(gameCanvas);
	        	}
	        	
	        }
    	}
    }
    
    
    public void onDataEvent(int actorSessionID, Hashtable datas) {
        if (mode == 3){
        	gameCanvas.onDataEvent(actorSessionID, datas);
        }
    }
    
    /**
     * Remove the player corresponding to the actorSessionID.
     * 
     * @param actorSessionID
     */
    private void removePlayer(int actorSessionID) {
    	try {
        	for(int i=0; i<gameSessionPlayers.size();i++){
                if (((Integer) gameSessionPlayers.elementAt(i)).intValue() == actorSessionID){
                  gameSessionPlayers.removeElementAt(i);
                break;
               }
               i++;
           }
    	}
    	catch (Exception e){
    	}
    }
 
    /**
     * Get the index of the aSID of in the gameSessionPlayers vector, else 0.
     *
     *@return index
     */
    private int getIndex(int aSessionID) {
        integer = Integer.valueOf(aSessionID+"");
    	return gameSessionPlayers.indexOf(integer);
    }
   
	/**
	 * @return Returns the mode.
	 */
	public int getMode() {
		return mode;
	}

	/***************************************************************************/
	/************************  Link to NetworkCom  *****************************/
	 /**These methods are used to transmit an event from IHMGasp to NetworkCom**/
	 /**************************************************************************/
	
	public void endAI() {
		networkCom.endAI(aSID);
	}


	public void quitAI() {
		networkCom.quitAI(aSID);
	}


	public void quit() {
		networkCom.quit(sID);
	}
	
	/**
	 * method is used to transmit a message from GameCanvas to NetworkCom
	 */
	public void sendMessage(Object o) {
		networkCom.addMessageToSend(o);
	}


	public Object update() {
		return gameCanvas.cyclicUpdateMessagesToSend();
	}
	public Object ping() {
		return gameCanvas.cyclicPingPlayerMessagesToSend();
	}
	
}
	
    
	
