/***
 * GASP: a gaming services platform for mobile multiplayer games.
 * MooDS: a communication protocol used in GASP.
 * GASP Demonstrator: a gasp demonstration game.
 *
 * Copyright (C) 2004 CNAM/INT
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 * 
 * Contact: gasp-team@objectweb.org
 *
 * Author: Franck Caron, Romain Pellerin
 */
/*
 * Created on 2 december 2005
 *
 * @author CARON Franck - CNAM CEDRIC
 * @author PELLERIN Romain - CNAM CEDRIC
 * @author DELPIANO Fabien - Filao
 * 
 * 
 * Research project: CNAM-CEDRIC - INT - Filao
 */
//#include parameters.h
////#define DEMO
////#define VERSION_SOLO
////#define FRANCK
////#define LASTPING
////#define RESYNC

//#endinclude

package app2.client.game;
import javax.microedition.lcdui.Canvas;
import javax.microedition.lcdui.Graphics;

import app2.client.NetworkCom;

public class HeroeActor extends Actor {

	private static final int NB_OF_MISSILES = 5, TIME_BETWEEN_SHOOTS = 200;

	//private Missile[] missiles;
	private long next_shoot = 0;

	/**
	 * @param game
	 */
	public HeroeActor(GameCanvas game) {
		super(game);
		
	//#ifdef DEMO
		//# missiles = new Missile[NB_OF_MISSILES];
		//# for (int i = 0; i < missiles.length; i++) {
		//#  missiles[i] = new Missile(game);
		//# }
	//#endif DEMO
	}
	/****************************/
	/*** Heroe initialization ***/
	/****************************/
	
	public void initialize() {
		this.x = 1000000;
		this.y = 1000000;
	}

	public void initializeHeroe(int x, int y, long moyPing) {
		this.x = x;
		this.y = y;
	}

	/*********************/
	/****** Actions ******/
	/*********************/
	
	public void executeActions(long time, long delta_time) {
		//super.executeActions(time, delta_time);

		if (game.isKeyPressed(Canvas.RIGHT)) {
			moveX(1500, delta_time);
			game.canUpdate = true;
		}
		if (game.isKeyPressed(Canvas.LEFT)) {
			moveX(-1500, delta_time);
			game.canUpdate = true;
		}
		if (game.isKeyPressed(Canvas.DOWN)){
			moveY(1500, delta_time);
			game.canUpdate = true;
		}
		if (game.isKeyPressed(Canvas.UP)){
			moveY(-1500, delta_time);
			game.canUpdate = true;
		}
		if (game.isKeyPressed(Canvas.FIRE)) {
			if (time > next_shoot) {

				/*for (int i = 0; i < missiles.length; i++) {
					Missile current = missiles[i];
					if (!current.isInGame()) {
						current.initializeMissile(getX(), getY());
						game.addActor(current);
						next_shoot = time + TIME_BETWEEN_SHOOTS;
						break;
					}
				}*/
				
			}
		}

	}
	/*********************/
	/****** Graphic ******/
	/*********************/

	public void paint(Graphics g, long gameTime, long deltaTime) {
		super.paint(g, gameTime, deltaTime);
		g.setColor(0xCC0000);
		g.drawString(username, game.convertToScreenX(getX()), game.convertToScreenY(getY())+5, Graphics.TOP | Graphics.HCENTER);
		g.drawString("ping "+ NetworkCom.averagePing, game.convertToScreenX(getX()), game.convertToScreenY(getY())-20, Graphics.TOP | Graphics.HCENTER);
	}
	

	/*****************************/
	/*** Collisions management ***/
	/*****************************/
	
	/**
	 * This part is to manage collision between actor and/or other objects. It's not include in this demostrator.
	 */
//#ifdef DEMO	
	//# public boolean isCollidableWith(Actor actor) {
		//# if (actor instanceof Missile) return false;
		//# return true;
	//# }
	//# 
	//# public boolean isMainCollider() {
		//# return true;
	//# }
	//# public boolean isNotifiedForCollision() {
		//# return true;
	//# }
	//# public void addCollision(Actor actor, long time, long delta_time) {
	//# 		game.looseLife();
	//# }
	//# 
//#endif DEMO
}
